/*
 * This test doesn't do much, just want to see if it compiles.  Mostly Looking 
 * for ambiguity errors calling the hideous mess of overloads of send, recv,
 * sendto and recvfrom for different parameter sets, and also errors in the
 * template functions for using std::array<> that might not show up until
 * instantation.
 */

#include <array>
#include <string>
#include <stdexcept>

#include "cleansocks.h"
#include "cleanip.h"
#include "cleanbuf.h"
using namespace cleansocks;

struct foo {
	int a;
	short s1,s2;
	char b[20];
};

void mainly()
{
	TCPsocket t1, t2;
	UDPsocket u1, u2;
	buffered_socket bs1(t1), bs2(t2);

	IPendpoint ipe;

	char buf1[40], buf2[30];
	int arr1[30];
	foo f1;
	std::string alvin("This is alvin");
	std::array<char, 20> ca20;
	std::array<unsigned char, 15> uca15;

	// All the send forms we want to work.
	send(t1, buf1, sizeof buf1);
	send(t1, buf1, sizeof buf1, CSMSG_DONTROUTE);
	send(t1, &f1, sizeof f1);
	send(t2, alvin);
	send(t2, alvin, CSMSG_DONTROUTE);
	send(t1, ca20);
	send(t1, ca20, 10);
	send(t1, ca20, 10, CSMSG_DONTROUTE);
	send(t1, ca20, CSMSG_DONTROUTE);
	send(t2, uca15);
	send(t2, uca15, 10);
	send(t2, uca15, 10, CSMSG_DONTROUTE);
	send(t2, uca15, CSMSG_DONTROUTE);

	// All the recv forms we want to work.
	recv(t1, buf1, sizeof buf1);
	recv(t2, buf1, sizeof buf1, CSMSG_WAITALL);
	recv(t1, &f1, sizeof f1);
	recv(t1, ca20);
	recv(t2, ca20, 10);
	recv(t2, ca20, 10, CSMSG_WAITALL);
	recv(t1, ca20, CSMSG_WAITALL);
	recv(t2, uca15);
	recv(t2, uca15, 10);
	recv(t2, uca15, 10, CSMSG_WAITALL);
	recv(t2, uca15, CSMSG_WAITALL);

	// All of the above should work with buffered sockets also
	send(bs1, buf1, sizeof buf1);
	send(bs1, buf1, sizeof buf1, CSMSG_DONTROUTE);
	send(bs1, &f1, sizeof f1);
	send(bs2, alvin);
	send(bs2, alvin, CSMSG_DONTROUTE);
	send(bs1, ca20);
	send(bs1, ca20, 10);
	send(bs1, ca20, 10, CSMSG_DONTROUTE);
	send(bs1, ca20, CSMSG_DONTROUTE);
	send(bs2, uca15);
	send(bs2, uca15, 10);
	send(bs2, uca15, 10, CSMSG_DONTROUTE);
	send(bs2, uca15, CSMSG_DONTROUTE);

	recv(bs1, buf1, sizeof buf1);
	recv(bs2, buf1, sizeof buf1, CSMSG_WAITALL);
	recv(bs1, &f1, sizeof f1);
	recv(bs1, ca20);
	recv(bs2, ca20, 10);
	recv(bs2, ca20, 10, CSMSG_WAITALL);
	recv(bs1, ca20, CSMSG_WAITALL);
	recv(bs2, uca15);
	recv(bs2, uca15, 10);
	recv(bs2, uca15, 10, CSMSG_WAITALL);
	recv(bs2, uca15, CSMSG_WAITALL);

	// Now, recvln.  Gave up on a few combos with std::array.
	// Here's what should work.
	recvln(bs1, buf1, sizeof buf1);
	recvln(bs1, buf1, sizeof buf1, CSMSG_WAITALL);
	recvln(bs1, buf1, sizeof buf1, '@', CSMSG_WAITALL);
	recvln(bs1, buf2, sizeof buf2, 'x');
	recvln(bs2, &f1, sizeof f1);
	recvln(bs2, &f1, sizeof f1, 0, CSMSG_WAITALL);
	recvln(bs2, &f1, sizeof f1, '+');
	recvln(bs2, &f1, sizeof f1, CSMSG_PEEK);
	recvln(bs2, ca20);
	recvln(bs2, ca20, 10);
	recvln(bs1, ca20, CSMSG_WAITALL);
	recvln(bs2, ca20, 10, 'X', CSMSG_WAITALL);
	recvln(bs1, ca20, 'y', CSMSG_WAITALL);
	recvln(bs2, uca15);
	recvln(bs2, uca15, 10);
	recvln(bs2, uca15, 10, static_cast<unsigned char>(201), CSMSG_WAITALL);
	recvln(bs2, uca15, CSMSG_WAITALL);

	// Let's see about sendto.  These are the same as send with the
	// destination added.
	sendto(u1, buf1, sizeof buf1, ipe);
	sendto(u1, buf1, sizeof buf1, CSMSG_DONTROUTE, ipe);
	sendto(u1, &f1, sizeof f1, ipe);
	sendto(u2, alvin, ipe);
	sendto(u2, alvin, CSMSG_DONTROUTE, ipe);
	sendto(u1, ca20, ipe);
	sendto(u1, ca20, 10, ipe);
	sendto(u1, ca20, 10, CSMSG_DONTROUTE, ipe);
	sendto(u1, ca20, CSMSG_DONTROUTE, ipe);
	sendto(u2, uca15, ipe);
	sendto(u2, uca15, 10, ipe);
	sendto(u2, uca15, 10, CSMSG_DONTROUTE, ipe);
	sendto(u2, uca15, CSMSG_DONTROUTE, ipe);

	// And recvfrom.  The location is optional
	recvfrom(u1, buf1, sizeof buf1, ipe);
	recvfrom(u1, buf1, sizeof buf1);
	recvfrom(u1, buf1, sizeof buf1, CSMSG_WAITALL, ipe);
	recvfrom(u1, buf1, sizeof buf1, CSMSG_WAITALL);
	recvfrom(u1, &f1, sizeof f1, ipe);
	recvfrom(u1, &f1, sizeof f1);
	recvfrom(u1, ca20, ipe);
	recvfrom(u1, ca20);
	recvfrom(u1, ca20, 10, ipe);
	recvfrom(u1, ca20, 10);
	recvfrom(u1, ca20, 10, CSMSG_WAITALL, ipe);
	recvfrom(u1, ca20, 10, CSMSG_WAITALL);
	recvfrom(u1, ca20, CSMSG_WAITALL, ipe);
	recvfrom(u1, ca20, CSMSG_WAITALL);
	recvfrom(u2, uca15, ipe);
	recvfrom(u2, uca15);
	recvfrom(u2, uca15, 10, ipe);
	recvfrom(u2, uca15, 10);
	recvfrom(u2, uca15, 10, CSMSG_WAITALL, ipe);
	recvfrom(u2, uca15, 10, CSMSG_WAITALL);
	recvfrom(u2, uca15, CSMSG_WAITALL, ipe);
	recvfrom(u2, uca15, CSMSG_WAITALL);
}

int main()
{
	try {
		mainly();
	} catch (std::exception &e) {
		
	}
}
