# This file is part of the Cleansocks library.  It is released under the
# Lesser GNU GPL.  See the accompanying files COPYING and COPYING.LESSER.

# They like these now.
Unicode true

# define installer name
OutFile "cleansocksinstall.exe"

Name "Cleansocks Library"

# See if the tls section executes.
Var install_tls

# The install directory
InstallDir "$PROGRAMFILES\cleansocks"
 
#Page instfiles
LicenseData licsum.txt
Page license
Page components
Page instfiles

# Base library.
Section "Cleansocks Base" 
SectionIn RO

StrCpy $install_tls "no"
 
# Copy the license text
SetOutPath $INSTDIR
File ../COPYING
File ../COPYING.LESSER

# Create the include directory and copy the base cleansocks includes.
CreateDirectory $INSTDIR\include
SetOutPath $INSTDIR\include
File ../cleanversion.h
File ../cleansri.h
File ../cleanflags.h
File ../cleanip.h
File ../cleansocks.h
File ../cleanbuf.h
File ../cleansrf2sr.h

# Now the library directory, and the cleansocks library.
CreateDirectory $INSTDIR\lib
CreateDirectory $INSTDIR\lib\32
SetOutPath $INSTDIR\lib\32
File 32/libcleansocks.a
CreateDirectory $INSTDIR\lib\64
SetOutPath $INSTDIR\lib\64
File 64/libcleansocks.a

# Record us.
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\cleansocks" "DisplayName" "CleanSocks - High-Level Socket Library"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\cleansocks" "UninstallString" "$\"$INSTDIR\uninstaller.exe$\""
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\cleansocks" "InstallLocation" "$\"$INSTDIR$\""

# Create the ununstaller.
WriteUninstaller $INSTDIR\uninstaller.exe

# Base section end
SectionEnd

Section "TLS Client"  
StrCpy $install_tls "tlsc"

# Additional headers
SetOutPath $INSTDIR\include
File ../cleanbio.h
File ../cleantlsc.h

# Additional libs
SetOutPath $INSTDIR\lib\32
File 32/libcleantlsc.a
File 32/libcrypto.a
File 32/libssl.a
SetOutPath $INSTDIR\lib\64
File 64/libcleantlsc.a
File 64/libcrypto.a
File 64/libssl.a

# And the root cert list.
SetOutPath $INSTDIR
File /oname=ca.pem cacert.pem

SectionEnd
 
# create a section to define what the uninstaller does.
# the section will always be named "Uninstall"
Section "Uninstall"

MessageBox MB_OKCANCEL "Do you want to uninstall cleansocks?" IDOK doremove
Abort "Uninstall Cancelled"

doremove:

# Always delete uninstaller first
Delete $INSTDIR\uninstaller.exe
 
# Get rid of the libraries.
Delete $INSTDIR\lib\32\libcleansocks.a
Delete $INSTDIR\lib\32\libcleantlsc.a
Delete $INSTDIR\lib\32\libgdi32.a
Delete $INSTDIR\lib\32\libcrypto.a
Delete $INSTDIR\lib\32\libssl.a
Delete $INSTDIR\lib\32\libmsvcrt.a
Delete $INSTDIR\lib\32\libz.a
Delete $INSTDIR\lib\32\libssp.a
Delete $INSTDIR\lib\32\libwsock32.a
Delete $INSTDIR\lib\32\libmincore.a
Delete $INSTDIR\lib\32\libcrtdll.a

Delete $INSTDIR\lib\64\libcleansocks.a
Delete $INSTDIR\lib\64\libcleantlsc.a
Delete $INSTDIR\lib\64\libgdi32.a
Delete $INSTDIR\lib\64\libcrypto.a
Delete $INSTDIR\lib\64\libssl.a
Delete $INSTDIR\lib\64\libmsvcrt.a
Delete $INSTDIR\lib\64\libz.a
Delete $INSTDIR\lib\64\libssp.a
Delete $INSTDIR\lib\64\libwsock32.a
Delete $INSTDIR\lib\64\libmincore.a
Delete $INSTDIR\lib\64\libcrtdll.a

RMDir $INSTDIR\32\lib
RMDir $INSTDIR\64\lib
RMDir $INSTDIR\lib

# Lose the include files
Delete $INSTDIR\include\clean*.h
RMDir $INSTDIR\include

Delete $INSTDIR\ca.pem
Delete $INSTDIR\COPYING
Delete $INSTDIR\COPYING.LESSER
RMDir $INSTDIR

DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\cleansocks"

SectionEnd
